using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinForms.Day4 {

   public class Listing49 : Form {
      Button btAccept = new Button();
      Button btCancel = new Button();
      Label lblMessage = new Label();
      VScrollBar vbarForm = new VScrollBar();
      HScrollBar hbarForm = new HScrollBar();

      public Listing49() {
         lblMessage.Location = new Point(75,150);
         lblMessage.Width = 200;

         btAccept.Location = new Point(100,25);
         btAccept.Text = "Accept";
         btAccept.Click += new EventHandler(this.AcceptIt);

         btCancel.Location = new Point(100,100);
         btCancel.Text = "Cancel";
         btCancel.Click += new EventHandler(this.CancelIt);

         vbarForm.Dock = DockStyle.Right;
         vbarForm.Visible = false;
         vbarForm.Click += new EventHandler(this.HandleScroll);
         hbarForm.Dock = DockStyle.Bottom;
         hbarForm.Visible = false;
         hbarForm.Click += new EventHandler(this.HandleScroll);

         this.Resize += new EventHandler(this.Resized);
         this.AcceptButton = btAccept;
         this.CancelButton = btCancel;
         this.Text = "Accept and Cancel Button Example";
         this.Height = 200;
         this.Controls.Add(lblMessage);
         this.Controls.Add(btAccept);
         this.Controls.Add(btCancel);
         this.Controls.Add(vbarForm);
         this.Controls.Add(hbarForm);
      }
   
      public void HandleScroll(Object Sender, EventArgs e) {

      }

      public void Resized(Object Sender, EventArgs e) {
         if (this.Height < lblMessage.Top + lblMessage.Height) {
            vbarForm.Visible = true;
         } else {
            vbarForm.Visible = false;
         }

         if (this.Width < btAccept.Left + btAccept.Width) {
            hbarForm.Visible = true;
         } else {
            hbarForm.Visible = false;
         }
         this.Refresh();
      }

      public void AcceptIt(Object Sender, EventArgs e) {
         lblMessage.Text = "Accept button pressed";
      }

      public void CancelIt(Object Sender, EventArgs e) {
         lblMessage.Text = "Cancel button pressed";
      }
   }

   public class StartForm {
      public static void Main() {
         Application.Run(new Listing49());
      }
   }
}