using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinForms.Day6 {

   public class Listing66 : Form {
      private TabControl tcMain = new TabControl();
      private TabPage tpGeneral = new TabPage("General");
      private TabPage tpDisplay = new TabPage("Display");
      private TabPage tpLocation = new TabPage("Location");
      private TabPage tpAdvanced = new TabPage("Advanced");

      private Label lbl1Name = new Label();
      private TextBox tb2Color = new TextBox();
      private Button bt2Color = new Button();
      private TextBox tb3Top = new TextBox();
      private TextBox tb3Left = new TextBox();
      private Button bt3Location = new Button();
      private TextBox tb4Tab = new TextBox();
      private Button bt4Tab = new Button();

      public Listing66() {
         // Tab Page 1
         lbl1Name.Text = "Listing 6.6: Teach Yourself Windows Forms in 21 Days";
         lbl1Name.AutoSize = true;
         lbl1Name.Location = new Point(10,75);

         // Tab Page 2
         tb2Color.Location = new Point(25,75);

         bt2Color.Text = "Change!";
         bt2Color.Location = new Point(125,75);
         bt2Color.Click += new EventHandler(this.ChangeColor);

         // Tab Page 3
         tb3Top.Text = this.DesktopLocation.Y.ToString();
         tb3Top.Location = new Point(25,50);
         tb3Left.Text = this.DesktopLocation.X.ToString();
         tb3Left.Location = new Point(25,75);

         bt3Location.Text = "Change!";
         bt3Location.Location = new Point(125,75);
         bt3Location.Click += new EventHandler(this.ChangeLocation);

         // Tab Page 4
         tb4Tab.Location = new Point(25,50);

         bt4Tab.Text = "Add Tab!";
         bt4Tab.Location = new Point(75,75);
         bt4Tab.Click += new EventHandler(this.AddTab); 

         tpGeneral.Controls.Add(lbl1Name);
         tpDisplay.Controls.Add(tb2Color);
         tpDisplay.Controls.Add(bt2Color);
         tpLocation.Controls.Add(tb3Top);
         tpLocation.Controls.Add(tb3Left);
         tpLocation.Controls.Add(bt3Location);
         tpAdvanced.Controls.Add(tb4Tab);
         tpAdvanced.Controls.Add(bt4Tab);

         tcMain.HotTrack = true;
         tcMain.Width = this.Width;
         tcMain.Height = this.Height;
         tcMain.TabPages.Add(tpGeneral);
         tcMain.TabPages.Add(tpDisplay);
         tcMain.TabPages.Add(tpLocation);
         tcMain.TabPages.Add(tpAdvanced);

         this.Text = "Listing 6.6";
         this.Controls.Add(tcMain);
      }

      public void ChangeColor(Object Sender, EventArgs e) {
         int i;

         for (i = 0; i < tcMain.TabPages.Count; i++) {
            tcMain.TabPages[i].BackColor = Color.FromName(tb2Color.Text);
         }
      }

      public void ChangeLocation(Object Sender, EventArgs e) {
         this.DesktopLocation = new Point(Convert.ToInt32(tb3Top.Text), Convert.ToInt32(tb3Left.Text));
      }

      public void AddTab(Object Sender, EventArgs e) {
         tcMain.TabPages.Add(new TabPage(tb4Tab.Text));
      }

      public static void Main() {
         Application.Run(new Listing66());
      }
   }
}