using System;
using System.Windows.Forms;
using System.Drawing;
using System.Data;

namespace TYWinforms.Day8 {
   public class Listing84 : Form {
      private DataGrid dgData = new DataGrid();
      private DataTable MyTable = new DataTable("Colors");

      public Listing84() {
         DataColumn colName = new DataColumn();
         colName.DataType = System.Type.GetType("System.String");
         colName.ColumnName = "Color Name";

         DataColumn colR = new DataColumn();
         colR.DataType = System.Type.GetType("System.Int32");
         colR.ColumnName = "Red";

         DataColumn colG = new DataColumn();
         colG.DataType = System.Type.GetType("System.Int32");
         colG.ColumnName = "Green";

         DataColumn colB = new DataColumn();
         colB.DataType = System.Type.GetType("System.Int32");
         colB.ColumnName = "Blue";

         MyTable.Columns.Add(colName);
         MyTable.Columns.Add(colR);
         MyTable.Columns.Add(colG);
         MyTable.Columns.Add(colB);

         DataRow myDataRow;
         myDataRow = MyTable.NewRow();
         myDataRow["Color Name"] = Color.Blue.Name;
         myDataRow["Red"] = Color.Blue.R;
         myDataRow["Green"] = Color.Blue.G;
         myDataRow["Blue"] = Color.Blue.B;
         MyTable.Rows.Add(myDataRow);

         myDataRow = MyTable.NewRow();
         myDataRow["Color Name"] = Color.Red.Name;
         myDataRow["Red"] = Color.Red.R;
         myDataRow["Green"] = Color.Red.G;
         myDataRow["Blue"] = Color.Red.B;
         MyTable.Rows.Add(myDataRow);

         myDataRow = MyTable.NewRow();
         myDataRow["Color Name"] = Color.Green.Name;
         myDataRow["Red"] = Color.Green.R;
         myDataRow["Green"] = Color.Green.G;
         myDataRow["Blue"] = Color.Green.B;
         MyTable.Rows.Add(myDataRow);

         myDataRow = MyTable.NewRow();
         myDataRow["Color Name"] = Color.PapayaWhip.Name;
         myDataRow["Red"] = Color.PapayaWhip.R;
         myDataRow["Green"] = Color.PapayaWhip.G;
         myDataRow["Blue"] = Color.PapayaWhip.B;
         MyTable.Rows.Add(myDataRow);

         DataGridTableStyle dgtStyle = new DataGridTableStyle();
         dgtStyle.MappingName = "Colors";
         
         DataGridTextBoxColumn dgcNameStyle = new DataGridTextBoxColumn();
         dgcNameStyle.MappingName = "Color Name";
         dgcNameStyle.HeaderText = "Color Name";
         
         DataGridTextBoxColumn dgcRedStyle = new DataGridTextBoxColumn();
         dgcRedStyle.MappingName = "Red";
         dgcRedStyle.ReadOnly = true;
         dgcRedStyle.HeaderText = "Red";

         DataGridTextBoxColumn dgcGreenStyle = new DataGridTextBoxColumn();
         dgcGreenStyle.MappingName = "Green";
         dgcGreenStyle.ReadOnly = true;
         dgcGreenStyle.HeaderText = "Green";

         DataGridTextBoxColumn dgcBlueStyle = new DataGridTextBoxColumn();
         dgcBlueStyle.MappingName = "Blue";
         dgcBlueStyle.ReadOnly = true;
         dgcBlueStyle.HeaderText = "Blue";

         dgtStyle.GridColumnStyles.Add(dgcNameStyle);
         dgtStyle.GridColumnStyles.Add(dgcRedStyle);
         dgtStyle.GridColumnStyles.Add(dgcGreenStyle);
         dgtStyle.GridColumnStyles.Add(dgcBlueStyle);

         dgData.TableStyles.Add(dgtStyle);

         dgData.DataSource = MyTable;
         dgData.Dock = DockStyle.Fill;
         dgData.CurrentCellChanged += new EventHandler(this.HandleColor);

         this.Size = new Size(800,600);
         this.Controls.Add(dgData);
         this.Text = "Listing 8.4";
      }

      public void HandleColor(Object Sender, EventArgs e) {
         if (Color.FromName(dgData[dgData.CurrentCell].ToString()).IsKnownColor) {
            dgData.TableStyles[0].ForeColor = Color.FromName(dgData[dgData.CurrentCell].ToString());
         }
      }

      public static void Main() {
         Application.Run(new Listing84());
      }
   }
}