using System;
using System.Windows.Forms;
using System.Drawing;
using System.Data;
using System.Data.SqlClient;

namespace TYWinforms.Day9 {
   public class Exercise1 : Form {
      private DataGrid dgData = new DataGrid();
      private TextBox tbCommand = new TextBox();
      private Button btExecute = new Button();
      private DataSet objDS = new DataSet();
      private String strConn;

      public Exercise1() {
         strConn = "Initial Catalog=TYWinforms;Data Source=localhost;User ID=sa";

         tbCommand.Location = new Point(150,75);
         tbCommand.Multiline = true;
         tbCommand.Height = 50;
         tbCommand.Width = 300;

         btExecute.Location = new Point(475,75);
         btExecute.Text = "Execute!";
         btExecute.Click += new EventHandler(this.Execute);

         dgData.Dock = DockStyle.Bottom;
         dgData.Size = new Size(800,400);
         dgData.Enabled = false;
         dgData.CurrentCellChanged += new EventHandler(this.UpdateData);
 
         this.Size = new Size(800,600);
         this.Text = "Exercise 1";
         this.Controls.Add(dgData);
         this.Controls.Add(tbCommand);
         this.Controls.Add(btExecute);
      }

      private void Execute(Object Sender, EventArgs e) {
         if (tbCommand.Text != "") {
            SqlConnection objConn = new SqlConnection(strConn);

            SqlDataAdapter objCmd = new SqlDataAdapter(tbCommand.Text, objConn);
            objDS.Clear();
            int intRows = objCmd.Fill(objDS, "Query");
         
            if (intRows > 0) {
               dgData.ResetBindings();
               dgData.DataSource = objDS;
               dgData.DataMember = "Query";
               dgData.Enabled = true;
            } else {
               dgData.Enabled = false;
            }
         }
      }

      public void UpdateData(Object Sender, EventArgs e) {
         SqlConnection objConn = new SqlConnection(strConn);
         SqlDataAdapter objCmd = new SqlDataAdapter(tbCommand.Text, objConn);
         SqlCommandBuilder objBuilder = new SqlCommandBuilder(objCmd);

         objCmd.Update(objDS, "Query");
      }

      public static void Main() {
         Application.Run(new Exercise1());
      }
   }
}