using System;
using System.Windows.Forms;
using System.Drawing;
using System.Data;
using System.Data.SqlClient;

namespace TYWinforms.Day10 {
   public class DataDocument : Form {
      private DataGrid dgData = new DataGrid();
      private DataSet objDS = new DataSet();
      private String strConn;
      private String strQuery;

      public DataDocument(string strName) {
         strConn = "Initial Catalog=TYWinforms;Data Source=localhost;User ID=sa";

         dgData.Dock = DockStyle.Fill;
         dgData.Enabled = false;
         dgData.CurrentCellChanged += new EventHandler(this.UpdateData);
 
         this.WindowState = FormWindowState.Maximized;
         this.Text = strName;
         this.Controls.Add(dgData);
      }

      public void Execute(string strQuery) {
         this.strQuery = strQuery;
 
         SqlConnection objConn = new SqlConnection(strConn);

         SqlDataAdapter objCmd = new SqlDataAdapter(strQuery, objConn);
         objDS.Clear();
         int intRows = objCmd.Fill(objDS, "Query");
         
         if (intRows > 0) {
            dgData.ResetBindings();
            dgData.DataSource = objDS;
            dgData.DataMember = "Query";
            dgData.Enabled = true;
         } else {
            dgData.Enabled = false;
         }
      }

      public void UpdateData(Object Sender, EventArgs e) {
         SqlConnection objConn = new SqlConnection(strConn);
         SqlDataAdapter objCmd = new SqlDataAdapter(strQuery, objConn);
         SqlCommandBuilder objBuilder = new SqlCommandBuilder(objCmd);

         objCmd.Update(objDS, "Query");
      }
   }
}