using System;
using System.Windows.Forms;
using System.Drawing;
using System.IO;

namespace TYWinforms.Day11 {
   public class Listing111 : Form {
      private TreeView tvFiles = new TreeView();
      private Label lblInfo = new Label();

      public Listing111() {
         tvFiles.Dock = DockStyle.Left;
         tvFiles.Width = 150;
         tvFiles.AfterSelect += new TreeViewEventHandler(this.DisplayInfo);

         lblInfo.Size = new Size(150,150);
         lblInfo.Location = new Point(160,10);
         lblInfo.Text = "Select a file or\ndirectory";

         PopulateList("c:\\", tvFiles.Nodes.Add("c:\\"));

         this.Controls.Add(tvFiles);
         this.Controls.Add(lblInfo);         
      }

      private void PopulateList(String strPath, TreeNode currNode) {
         DirectoryInfo dir = new DirectoryInfo(strPath);
         TreeNode nodeSubDir;

         foreach (DirectoryInfo d in dir.GetDirectories("w*")) {
            nodeSubDir = currNode.Nodes.Add(d.Name);
            PopulateList(d.FullName, nodeSubDir);
         }

         foreach (FileInfo f in dir.GetFiles("*.*")) {
            currNode.Nodes.Add(f.Name);
         }
      }

      private void DisplayInfo(Object Sender, TreeViewEventArgs e) {
         TreeNode tempNode = e.Node;
         String strFullName = tempNode.Text;

         while (tempNode.Parent != null) {
            strFullName = tempNode.Parent.Text + "\\" + strFullName;
            tempNode = tempNode.Parent;
         }

         if (File.Exists(strFullName)) {
            FileInfo obj = new FileInfo(strFullName);
            lblInfo.Text = "Name: " + obj.Name;
            lblInfo.Text += "\nSize: " + obj.Length;
            lblInfo.Text += "\nAccessed: " + obj.LastAccessTime.ToString();
         } else {
            DirectoryInfo obj = new DirectoryInfo(strFullName);
            lblInfo.Text = "Name: " + obj.Name;
            lblInfo.Text += "\nAttributes: " + obj.Attributes.ToString();
            lblInfo.Text += "\nAccessed: " + obj.LastAccessTime.ToString();
         }
      }

      public static void Main() {
         Application.Run(new Listing111());
      }
   }
}