using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace TYWinforms.Day13 {
   public class Listing135 : Form {
      public Listing135() {
         this.Text = "Listing 13.5";
         this.Size = new Size(800,600);
      }

      protected override void OnPaint(PaintEventArgs e) {
         Graphics objGraphics = e.Graphics;

         Pen objPen = new Pen(Color.Black);

         //simple black line
         objGraphics.DrawLine(objPen, new Point(10,700), new Point(500,150));

         //thicker line
         objPen.Color = Color.Red;
         objPen.Width = 10;
         objPen.Alignment = PenAlignment.Inset;
         objGraphics.DrawLine(objPen, new Point(50,200), new Point(500,430));

         //arrow
         objPen.Color = Color.Blue;
         objPen.EndCap = LineCap.DiamondAnchor;
         objPen.StartCap = LineCap.ArrowAnchor;
         objGraphics.DrawLine(objPen, new Point(600,10), new Point(500,430));

         //dashed line
         objPen.Color = Color.Green;
         objPen.EndCap = LineCap.NoAnchor;
         objPen.StartCap = LineCap.NoAnchor;
         objPen.DashStyle = DashStyle.DashDotDot;
         objGraphics.DrawLine(objPen, new Point(20,60), new Point(300,600));
      
      }

      public static void Main() {
         Application.Run(new Listing135());
      }
   }
}