using System;
using System.Windows.Forms;
using System.Drawing;
using System.Reflection;
using Word;

namespace TYWinforms.Day14 {
   public class Listing142 : Form {
      private Button btView = new Button();
      private Button btViewInWord = new Button();
      private RichTextBox rtbContent = new RichTextBox();

      private Word.Application appWord;
      private Word.Document docWord;
      private Word._Document docWorking;
      private Word.Documents colDocs;
      private Word.Range objRange;

      object arg = 0;
      private object missing = Missing.Value;

      public Listing142() {
         btView.Text = "Click Here to Open a Word Document";
         btView.Location = new Point(150,50);
         btView.Size = new Size(150,50);
         btView.Click += new EventHandler(this.OpenDoc);

         btViewInWord.Text = "Click Here to Open a Word Document in Word";
         btViewInWord.Location = new Point(350,50);
         btViewInWord.Size = new Size(150,50);
         btViewInWord.Click += new EventHandler(this.OpenDocInWord);

         rtbContent.Dock = DockStyle.Bottom;
         rtbContent.Size = new Size(800,400);

         this.Text = "Listing 14.2";
         this.Size = new Size(800,600);
         this.Controls.Add(btView);
         this.Controls.Add(btViewInWord);
         this.Controls.Add(rtbContent);
      }

      private void OpenDoc(Object Sender, EventArgs e) {
         OpenFileDialog dlgOpen = new OpenFileDialog();

         if (dlgOpen.ShowDialog() == DialogResult.OK) {
            InitializeWord(dlgOpen.FileName);
            rtbContent.Text = objRange.Text;
            CloseWord();
         }
      }

      private void OpenDocInWord(Object Sender, EventArgs e) {
         OpenFileDialog dlgOpen = new OpenFileDialog();

         if (dlgOpen.ShowDialog() == DialogResult.OK) {
            InitializeWord(dlgOpen.FileName);
            appWord.Visible = true;
         }
      }

      private void InitializeWord(string filename) {
         appWord = new Word.Application();
         colDocs = appWord.Documents;

         object strFilename = (object) filename;

         docWorking = (_Document)docWord;
         docWorking = colDocs.Open(ref strFilename, ref missing, ref missing, ref missing, ref missing, ref missing, ref missing, ref missing, ref missing, ref missing, ref missing, ref missing);
         objRange = docWorking.Range(ref missing,ref missing);	
      }

      private void CloseWord() {
         docWorking.Close(ref missing, ref missing, ref missing);
         (appWord).Quit(ref missing, ref missing, ref missing);
      }

      public static void Main()	{
         System.Windows.Forms.Application.Run(new Listing142());
      }
   }
}