using System;
using System.Windows.Forms;
using System.Drawing;
using System.Reflection;
using Excel;

namespace TYWinforms.Day14 {
   public class Listing143 : Form {
      private System.Windows.Forms.Button btAdd = new System.Windows.Forms.Button();
      private System.Windows.Forms.Button btSort = new System.Windows.Forms.Button();
      private ComboBox cboUnsorted = new ComboBox();
      private System.Windows.Forms.ListBox lbSorted = new System.Windows.Forms.ListBox();

      private Excel.Application objApp;
      private Workbooks colWBooks;
      private _Workbook objWBook;
      private Sheets colSheets;
      private _Worksheet objSheet;

      private object missing = Missing.Value;

      public Listing143() {
         btAdd.Text = "Add";
         btAdd.Location = new System.Drawing.Point(210,50);
         btAdd.Click += new EventHandler(this.Add);

         btSort.Text = "-> Sort It ->";
         btSort.Location = new System.Drawing.Point(300,250);
         btSort.Size = new Size(150,50);
         btSort.Click += new EventHandler(this.Sort);

         cboUnsorted.Location = new System.Drawing.Point(50,50);
         cboUnsorted.Size = new Size(150,500);
         cboUnsorted.DropDownStyle = ComboBoxStyle.Simple;         

         lbSorted.Location = new System.Drawing.Point(550,50);
         lbSorted.Size = new Size(150,500);

         this.Text = "Listing 14.3";
         this.Size = new Size(800,600);
         this.Controls.Add(btSort);
         this.Controls.Add(btAdd);
         this.Controls.Add(cboUnsorted);
         this.Controls.Add(lbSorted);
      }

      private void Add(Object Sender, EventArgs e) {
         cboUnsorted.Items.Add(cboUnsorted.Text);
         cboUnsorted.Text = "";
      }

      private void Sort(Object Sender, EventArgs e) {
         lbSorted.Items.Clear();
         int intCount = cboUnsorted.Items.Count;

         objApp = new Excel.Application();
         colWBooks = objApp.Workbooks;
         objWBook = colWBooks.Add(XlWBATemplate.xlWBATWorksheet);
         colSheets = objWBook.Worksheets;
         objSheet = (_Worksheet) colSheets.get_Item(1);

         Range objRange = objSheet.get_Range("A1", Convert.ToChar(intCount+64).ToString() + "1");

         String[] arrValues = new String[intCount];
         for (int i = 0; i < intCount; i++) {
            arrValues[i] = cboUnsorted.Items[i].ToString();
         }
         objRange.Value2 = arrValues;

         objRange.Sort(objSheet.Rows[1, Missing.Value], XlSortOrder.xlAscending, Missing.Value, Missing.Value, XlSortOrder.xlAscending, Missing.Value, XlSortOrder.xlAscending, XlYesNoGuess.xlNo, Missing.Value, Missing.Value, XlSortOrientation.xlSortRows, XlSortMethod.xlStroke);

         Object[,] arrSorted;
         arrSorted = (Object[,])objRange.Value;

         for (int i=arrSorted.GetLowerBound(0); i <= arrSorted.GetUpperBound(0); i++) {
            for (int j=arrSorted.GetLowerBound(1); j <= arrSorted.GetUpperBound(1); j++) {
               lbSorted.Items.Add(arrSorted[i,j]);
            }
         }

         cboUnsorted.Items.Clear();
         
         objWBook.Saved = true;
         objApp.Quit();
      }

      public static void Main()	{
         System.Windows.Forms.Application.Run(new Listing143());
      }
   }
}