Imports System
Imports System.ServiceProcess
Imports System.IO
Imports System.Timers

namespace TYWinforms.Day16

   Public Class BackUpper : Inherits ServiceBase
      private tmrTimer As New Timer()
      private strTo As String = "c:\temp\mybackups"
      private strFrom As String = "C:\Documents and Settings\Christopher L Payne.CHRISMAN\My Documents"

      Public Sub New()
         tmrTimer.Interval = 10000
         AddHandler tmrTimer.Elapsed, new ElapsedEventHandler(AddressOf Me.BackUpNow)

         Me.ServiceName = "TYWinforms Backup Service"
      End Sub

      Shared Sub Main()
         ServiceBase.Run(New BackUpper())
      End Sub

      Protected Overrides Sub OnStart(ByVal args() As String)
         Dim dir As New DirectoryInfo(strTo)

         if not dir.Exists then
            dir.Create()
         end if

         tmrTimer.Enabled = true
      End Sub

      private sub BackUpNow(Sender As Object, e as ElapsedEventArgs)      
         BackItUp(strFrom)
      end sub

      private sub BackItUp(strLocalFrom)
         Dim dirFrom As New DirectoryInfo(strLocalFrom)
         Dim d As DirectoryInfo
         Dim dirTo As DirectoryInfo
         Dim f as FileInfo

         ' Uncomment the below code to do a recursive backup
         'for each d in dirFrom.GetDirectories()
         '   dirTo = New DirectoryInfo(d.FullName.Replace(strFrom,strTo))
         '   if not dirTo.Exists then
         '      dirTo.Create()
         '   end if

         '   BackItUp(d.FullName)
         'next

         for each f in dirFrom.GetFiles("*.*")
            f.CopyTo(f.FullName.Replace(strFrom,strTo), true)
         next

         EventLog.WriteEntry("Contents of " & strLocalFrom & " backed up")

      end sub

   End Class
end namespace