using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinForms.Day17 {

   public class Listing174 : Form {
      private MainMenu mnuCustom = new MainMenu();
      private MenuItem miCustom = new MenuItem();
      private MenuItem miRed = new MenuItem();
      private MenuItem miBlue = new MenuItem();
      private MenuItem miOrange = new MenuItem();
      private MenuItem miGreen = new MenuItem();

      public Listing174() {
         this.Text = "Listing 17.4";
         this.Menu = mnuCustom;

         miCustom = mnuCustom.MenuItems.Add("Custom Menu");
         miRed = miCustom.MenuItems.Add("Red");
         miBlue = miCustom.MenuItems.Add("Blue");
         miOrange = miCustom.MenuItems.Add("Orange");
         miGreen = miCustom.MenuItems.Add("Green");

         miCustom.OwnerDraw = true;
         miCustom.DrawItem += new DrawItemEventHandler(this.DrawTopLevel);
         miCustom.MeasureItem += new MeasureItemEventHandler(this.MeasureItem);

         miRed.OwnerDraw = true;
         miRed.DrawItem += new DrawItemEventHandler(this.DrawItem);
         miRed.MeasureItem += new MeasureItemEventHandler(this.MeasureItem);

         miBlue.OwnerDraw = true;
         miBlue.DrawItem += new DrawItemEventHandler(this.DrawItem);
         miBlue.MeasureItem += new MeasureItemEventHandler(this.MeasureItem);

         miOrange.OwnerDraw = true;
         miOrange.DrawItem += new DrawItemEventHandler(this.DrawItem);
         miOrange.MeasureItem += new MeasureItemEventHandler(this.MeasureItem);

         miGreen.OwnerDraw = true;
         miGreen.DrawItem += new DrawItemEventHandler(this.DrawItem);
         miGreen.MeasureItem += new MeasureItemEventHandler(this.MeasureItem);
      }

      private void MeasureItem(Object Sender, MeasureItemEventArgs e) {
         SizeF stringSize = e.Graphics.MeasureString(((MenuItem)Sender).Text, this.Font);

         e.ItemHeight = (int)stringSize.Height + 6;
         e.ItemWidth = (int)stringSize.Width + 10;
      }

      private void DrawTopLevel(Object Sender, DrawItemEventArgs e) {
         if (((e.State & DrawItemState.HotLight) == DrawItemState.HotLight) | (e.State & DrawItemState.Selected) == DrawItemState.Selected) { 
            e.Graphics.DrawString(((MenuItem)Sender).Text, new Font("Times New Roman",12), Brushes.Blue, new Point(e.Bounds.X, e.Bounds.Y));
         } else {
            e.Graphics.DrawString(((MenuItem)Sender).Text, new Font("Times New Roman",12), Brushes.Black, new Point(e.Bounds.X, e.Bounds.Y));
         }
      }

      private void DrawItem(Object Sender, DrawItemEventArgs e) {
         e.Graphics.FillRectangle(Brushes.WhiteSmoke, new Rectangle(e.Bounds.X, e.Bounds.Y, e.Bounds.Width, e.Bounds.Height));

         if (((e.State & DrawItemState.HotLight) == DrawItemState.HotLight) | (e.State & DrawItemState.Selected) == DrawItemState.Selected) { 
            e.Graphics.FillRectangle(Brushes.LightGray, new Rectangle(e.Bounds.X, e.Bounds.Y, e.Bounds.Width, e.Bounds.Height));
            e.Graphics.DrawString(((MenuItem)Sender).Text, new Font("Times New Roman",12), Brushes.Blue, new Point(e.Bounds.X, e.Bounds.Y));
         } else {
            e.Graphics.DrawString(((MenuItem)Sender).Text, new Font("Times New Roman",12), Brushes.Black, new Point(e.Bounds.X, e.Bounds.Y));
         }
      }

      public static void Main() {
         Application.Run(new Listing174());
      }
   }

}