using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinForms.Day17 {
   public class Listing172 : Form {
      private ComboBox cboItems = new ComboBox();
      private Image[] arrImages;

      public Listing172() {
         arrImages = new Image[] {Image.FromFile("c:\\winforms\\day17\\icon1.bmp"), Image.FromFile("c:\\winforms\\day17\\icon2.bmp"), Image.FromFile("c:\\winforms\\day17\\icon3.bmp"), Image.FromFile("c:\\winforms\\day17\\icon4.bmp"), Image.FromFile("c:\\winforms\\day17\\icon5.bmp")};

         cboItems.Location = new Point(50,25);
         cboItems.Size = new Size(200,200);
         cboItems.DropDownStyle = ComboBoxStyle.Simple;

         cboItems.Items.Add("Item 1");
         cboItems.Items.Add("Item 2");
         cboItems.Items.Add("Item 3");
         cboItems.Items.Add("Item 4");
         cboItems.Items.Add("Item 5");

         cboItems.DrawMode = DrawMode.OwnerDrawVariable;
         cboItems.DrawItem += new DrawItemEventHandler(this.DrawMyBox);
         cboItems.MeasureItem += new MeasureItemEventHandler(this.MeasureIt);

         this.Text = "Listing 17.2";
         this.Controls.Add(cboItems);
      }

      public void MeasureIt(Object Sender, MeasureItemEventArgs e) {
         e.ItemHeight = (int)(arrImages[e.Index].Height);
      }

      public void DrawMyBox(Object Sender, DrawItemEventArgs e) {
         e.DrawBackground();

         if ((e.State & DrawItemState.Selected) == DrawItemState.Selected) { 
            e.Graphics.FillRectangle(Brushes.Orange, new Rectangle(e.Bounds.X, e.Bounds.Y, e.Bounds.Width, e.Bounds.Height));
            e.Graphics.DrawString("Item " + e.Index + " selected!", new Font("Arial",14), Brushes.White, new Point(e.Bounds.X, e.Bounds.Y));
         } else {
            e.Graphics.DrawImage(arrImages[e.Index], new Point(e.Bounds.X, e.Bounds.Y));
            e.Graphics.DrawString("Item " + e.Index, new Font("Arial",10), Brushes.Black, new Point((int)(arrImages[e.Index].Width + 2), e.Bounds.Y));
         }
      }

      public static void Main() {
         Application.Run(new Listing172());
      }
   }

}