using System;
using System.Windows.Forms;
using System.Drawing;
using System.Diagnostics;

namespace TYWinforms.Day21 {
   public class Exercise : Form {
      private ListBox lbxProcesses = new ListBox();

      private Label lblCaptionId = new Label();
      private Label lblCaptionModule = new Label();
      private Label lblCaptionProcessor = new Label();
      private Label lblCaptionMemory = new Label();
      private Label lblCaptionThreadCount = new Label();

      private Label lblId = new Label();
      private TextBox tbModule = new TextBox();
      private Label lblProcessor = new Label();
      private Label lblMemory = new Label();
      private Label lblThreadCount = new Label();

      private System.Windows.Forms.Timer tmrProcess = new System.Windows.Forms.Timer();

      public Exercise() {
         lbxProcesses.Location = new Point(10,10);
         lbxProcesses.Width = 280;
         lbxProcesses.DisplayMember = "ProcessName";
         lbxProcesses.SelectedIndexChanged += new EventHandler(this.StartWatch);

         foreach (Process tmpProcess in Process.GetProcesses()) {
            lbxProcesses.Items.Add(tmpProcess);
         }

         lblCaptionId.Location = new Point(10,120);
         lblCaptionId.Text = "PID:";
         lblCaptionModule.Location = new Point(10,150);
         lblCaptionModule.Text = "Modules:";
         lblCaptionProcessor.Location = new Point(10,180);
         lblCaptionProcessor.Text = "Processor Time:";
         lblCaptionMemory.Location = new Point(10,210);
         lblCaptionMemory.Text = "Memory:";
         lblCaptionThreadCount.Location = new Point(10,240);
         lblCaptionThreadCount.Text = "Thread Count:";

         lblId.Location = new Point(110,120);
         lblId.Width = 150;
         tbModule.Location = new Point(110,150);
         tbModule.Multiline = true;
         tbModule.Size = new Size(500,25);
         tbModule.ReadOnly = true;
         tbModule.ScrollBars = ScrollBars.Vertical;
         lblProcessor.Location = new Point(110,180);
         lblProcessor.Width = 150;
         lblMemory.Location = new Point(110,210);
         lblMemory.Width = 150;
         lblThreadCount.Location = new Point(110,240);
         lblThreadCount.Width = 150;

         tmrProcess.Tick += new EventHandler(this.Update);
         tmrProcess.Interval = 500;

         this.Text = ".NET Profiler";
         this.Width = 640;
         this.Controls.Add(lblCaptionId);
         this.Controls.Add(lblCaptionModule);
         this.Controls.Add(lblCaptionProcessor);
         this.Controls.Add(lblCaptionMemory);
         this.Controls.Add(lblCaptionThreadCount);
         this.Controls.Add(lbxProcesses);
         this.Controls.Add(lblId);
         this.Controls.Add(tbModule);
         this.Controls.Add(lblProcessor);
         this.Controls.Add(lblMemory);
         this.Controls.Add(lblThreadCount);
      }

      private void StartWatch(Object Sender, EventArgs e) {
         //put things that don't change here
         try {
            Process tmpProcess = (Process)lbxProcesses.SelectedItem;

            tbModule.Text = "";
            foreach (ProcessModule tmpModule in tmpProcess.Modules) {
               tbModule.Text += tmpModule.ModuleName + " ";
            }
            lblId.Text = tmpProcess.Id.ToString();

            tmrProcess.Start();
         } catch (Exception ex) {
            MessageBox.Show("That process is unwatchable");
         }
      }

      private void Update(Object Sender, EventArgs e) {
         try {
            Process tmpProcess = (Process)lbxProcesses.SelectedItem;

            tmpProcess.Refresh();
            lblMemory.Text = tmpProcess.PrivateMemorySize.ToString();
            lblProcessor.Text = tmpProcess.TotalProcessorTime.ToString();
            lblThreadCount.Text = tmpProcess.Threads.Count.ToString();
         } catch (Exception ex) {
            //do nothing
         }
      }

      public static void Main() {
         Application.Run(new Exercise());
      }
   }
}