using System;
using System.Windows.Forms;
using System.Drawing;

namespace TYWinforms.P3 {
   public class FindDialog : Form {
      private Label lblFind = new Label();
      private Label lblReplace = new Label();
      private TextBox tbFind = new TextBox();
      private TextBox tbReplace = new TextBox();
      private Button btFind = new Button();
      private Button btReplace = new Button();
      private Button btReplaceAll = new Button();
      private Button btCancel = new Button();

      private RichTextBox rtbDoc;
      private Document docParent;

      public FindDialog(Form frmDocument): base() {
         docParent = (Document)frmDocument;

         lblFind.Text = "Find:";
         lblFind.Location = new Point(10,10);
         lblFind.Width = 50;

         lblReplace.Text = "Replace:";
         lblReplace.Location = new Point(10,35);
         lblReplace.Width = 50;

         tbFind.Width = 100;
         tbFind.Location = new Point(60,10);

         tbReplace.Width = 100;
         tbReplace.Location = new Point(60,35);

         btFind.Size = new Size(75,25);
         btFind.Text = "Find";
         btFind.Location = new Point(170,10);
         btFind.Click += new EventHandler(this.ButtonClicked);

         btReplace.Size = new Size(75,25);
         btReplace.Text = "Replace";
         btReplace.Location = new Point(170,35);
         btReplace.Click += new EventHandler(this.ButtonClicked);

         btReplaceAll.Size = new Size(75,25);
         btReplaceAll.Text = "Replace All";
         btReplaceAll.Location = new Point(170,60);
         btReplaceAll.Click += new EventHandler(this.ButtonClicked);

         btCancel.Size = new Size(75,25);
         btCancel.Text = "Cancel";
         btCancel.Location = new Point(170,85);
         btCancel.Click += new EventHandler(this.ButtonClicked);

         this.Text = "Find";
         this.Size = new Size(255,140);
         this.MaximizeBox = false;
         this.MinimizeBox = false;
         this.FormBorderStyle = FormBorderStyle.FixedDialog;
         this.TopMost = true;

         this.Controls.Add(lblFind);
         this.Controls.Add(lblReplace);
         this.Controls.Add(tbFind);
         this.Controls.Add(tbReplace);
         this.Controls.Add(btFind);
         this.Controls.Add(btReplace);
         this.Controls.Add(btReplaceAll);
         this.Controls.Add(btCancel);
      }

      private void ButtonClicked(Object Sender, EventArgs e) {
         Button btTemp = (Button)Sender;
         int intLocation;
         int intCount = 0;

         switch (btTemp.Text) {
            case "Find":
               for (int i = docParent.intCurrentPage-1; i < docParent.arrPages.Count; i++) {

                  rtbDoc = (RichTextBox)docParent.arrPages[i];

                  if (i != docParent.intCurrentPage-1) {
                     rtbDoc.Focus();
                     rtbDoc.SelectionStart = 0;
                  }

                  intLocation = rtbDoc.Find(tbFind.Text, rtbDoc.SelectionStart + rtbDoc.SelectionLength, RichTextBoxFinds.None);
                  if (intLocation != -1) {
                     rtbDoc.SelectionStart = intLocation;
                     rtbDoc.SelectionLength = tbFind.Text.Length;
                     rtbDoc.Focus();
                     break;
                  }
               }
               break;
            case "Replace":
               for (int i = docParent.intCurrentPage-1; i < docParent.arrPages.Count; i++) {

                  rtbDoc = (RichTextBox)docParent.arrPages[i];

                  if (i != docParent.intCurrentPage-1) {
                     rtbDoc.Focus();
                     rtbDoc.SelectionStart = 0;
                  }

                  intLocation = rtbDoc.Find(tbFind.Text, rtbDoc.SelectionStart + rtbDoc.SelectionLength, RichTextBoxFinds.None);
                  if (intLocation != -1) {
                     rtbDoc.SelectionStart = intLocation;
                     rtbDoc.SelectionLength = tbFind.Text.Length;
                     rtbDoc.SelectedText = tbReplace.Text;
                     rtbDoc.SelectionStart = intLocation;
                     rtbDoc.SelectionLength = tbReplace.Text.Length;
                  }
               }
               break;
            case "Replace All":
               for (int i = 0; i < docParent.arrPages.Count; i++) {

                  rtbDoc = (RichTextBox)docParent.arrPages[i];

                  if (i != docParent.intCurrentPage-1) {
                     rtbDoc.Focus();
                     rtbDoc.SelectionStart = 0;
                  }

                  intLocation = rtbDoc.Find(tbFind.Text);
                  while (intLocation != -1) {
                     rtbDoc.SelectionStart = intLocation;
                     rtbDoc.SelectionLength = tbFind.Text.Length;
                     rtbDoc.SelectedText = tbReplace.Text;
                     intCount += 1;
                     intLocation = rtbDoc.Find(tbFind.Text, rtbDoc.SelectionStart + rtbDoc.SelectionLength, RichTextBoxFinds.None);
                  }
               }
               MessageBox.Show(intCount.ToString() + " occurrences replaced","Find");
               break;
            case "Cancel":
               this.Close();
               break;
         }
      }
   }
}